//Automatizador de dispensador de agua - Elfego Arnoldo Rivas Galán - carnet 20704

//Incluir la librería del motor servo
#include <Servo.h> //librería para la librería servo
//Se declara el pin del motor
const int servo_pin =9;
Servo servo;

//Se declaran los pines del sensor ultrasónico
int trigger = 12;           
int echo = 11;          
#define MAX_DISTANCE 200
float tiempo_de_espera,distancia; //Se crea una flotante para dar una distancia con decimales.

int Buzzerpin = 8; // pin del buzzer


void setup() {
  Serial.begin (9600);   // Se inicia el monitor serial
  pinMode (trigger, OUTPUT); // declarmos el pin 12 como salida
  pinMode (echo, INPUT);   // declaramos el 11 como entrada
  pinMode (Buzzerpin, OUTPUT); //Se declara el pin del buzzer como salida
  pinMode(13, OUTPUT);//Se declara el pin del led
  servo.attach(servo_pin);  //el motor estará instalado en un punto en particular  
}


void loop() {
  //Función para la detección de distancia del sensor.
  delay (200);
  digitalWrite (trigger,LOW); 
  delayMicroseconds(2);
  digitalWrite (trigger, HIGH);
  delayMicroseconds (10);    
  digitalWrite (trigger, LOW); 
  tiempo_de_espera = pulseIn (echo,HIGH); 

  //Función para dar la distancia en el monitor serial.
  distancia =(tiempo_de_espera/2)/29.15; // formula para hallar la distancia
  Serial.print (distancia);    // imprimimos la distancia en cm
  Serial.println ("cm");
  delay (100);
  
  if (distancia > 25){ //Si la distancia es mayor a 25cm todo el circuito estará apagado
    servo.write(0); //grados
    delay(500);
    digitalWrite(13, LOW);
    delay(500);

  }
  else if((distancia > 5) && (distancia < 25)){ //Si la distancia está entre 5cm y 25cm el motor girará y el led se encenderá
    servo.write(180); //grados
    delay(500);
    digitalWrite(13, HIGH);
    delay(500);
  }
  else if(distancia<5){ //Si la distancia es menor a 5cm el motor se apagará y el buzzer sonará como una alarma que dejará de caer agua.
    servo.write(0); //grados
    delay(500);
    alarma();
    digitalWrite(13, LOW);
    delay(500);
    
    
  }
}

void alarma (){ //Esta es la función de la alarma que sonará cuando se detenga el motor.
  digitalWrite(Buzzerpin,HIGH);
  delay(250);
  digitalWrite(Buzzerpin,LOW);
  delay(20);
  digitalWrite(Buzzerpin,HIGH);
  delay(100);
  digitalWrite(Buzzerpin,LOW);
  delay(20);
  digitalWrite(Buzzerpin,HIGH);
  delay(250);
  digitalWrite(Buzzerpin,LOW);
}
